/*********************************************************************
 * DrvHY2613.c
 * -------------------------------------------------------------------
 * Copyright 2014 HYCON Technology
 * http://www.hycontek.com/
 *
 * Release 
 *     2014/02/18
 *
 **********************************************************************/
/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "HY2613.h"
//#define HY2613C

/*----------------------------------------------------------------------------*/
/* Inital the LCD Drive                                                       */
/*----------------------------------------------------------------------------*/
void Ini_Display(void)
{
  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr equ  07Ch
  Sendbuf[0]  = ICSET|SWRst|OscModeInt;  //ICSET equ  0EAh
  Sendbuf[1]  = DISCTL|PoMode3|FrInv|PoHigh;  //DISCTL equ  0BFh
  Sendbuf[2]  = ADSET;  //ADSET equ  000h
  Sendbuf[3]  = ADSET;  //ADSET equ  000h
  I2C_RW = WRITE;             //

  DataTxLen=4;
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;

  /*--------------------------------------------------------------------------*/
  /* Extend Control                                                       */
  /*--------------------------------------------------------------------------*/
#if defined(HY2613C)
  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr equ  07Ch
  Sendbuf[0]  = EXCTL|SROn;  //
  I2C_RW = WRITE;             //

  DataTxLen=1;
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;

  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr equ  07Ch
  Sendbuf[0]  = VLCD_CTVR;  //
  Sendbuf[1]  = VLCD3p0|CTVR00;  //
  Sendbuf[2]  = ENBUF|VLCDEN01;  //
  I2C_RW = WRITE;             //

  DataTxLen=3;
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;

  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr equ  07Ch
  Sendbuf[0]  = EXCTL;  //
  I2C_RW = WRITE;             //

  DataTxLen=1;
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;
#endif
  /*--------------------------------------------------------------------------*/
  /* Open the LCD Drive                                                       */
  /*--------------------------------------------------------------------------*/
  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr 0x07C
  Sendbuf[0]  = DISCTL|PoMode3|FrInv|PoHigh;  //
  Sendbuf[1]  = BLKCTL;  //0xF0
  Sendbuf[2]  = PIXCTL;  //0xFC
  Sendbuf[3]  = MODE_SET|Dis_ON;  //0xC8
  I2C_RW = WRITE;             //

  DataTxLen=4;
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;
}

/*----------------------------------------------------------------------------*/
/* RAM Data Send to LCD                                                       */
/*----------------------------------------------------------------------------*/
void RAM2LCD(unsigned char *Buffer_Adr, unsigned int length)
{
  I2C_TARGET  = HY2613_Slave_addr;  //Slave_addr equ  07Ch
  Sendbuf[0]  = DISCTL|PoMode3|FrInv|PoHigh;  //
  Sendbuf[1]  = BLKCTL;  //0xf0
  Sendbuf[2]  = PIXCTL;  //0xfc
  Sendbuf[3]  = MODE_SET|Dis_ON;  //0xc8
  Sendbuf[4]  = ADSET;  //0x00  //LCD RAM
  I2C_RW = WRITE;             //
  DataTxLen=5;

  for(;length>0;length--)
  {
    Sendbuf[DataTxLen++]  = (*Buffer_Adr++);
  }
  DataTxIndex=0;
  EndFlag=0;
  DrvI2C_Ctrl(1,0,0,0);  /* I2C as master sends START signal */
  asm("NOP");
  while (EndFlag == 0);  /* Wait I2C Tx Finish */
  EndFlag = 0;
}
